function xnew = svd_diagram(A,fz,x,scl)

[U S V] = svd(A,0);
w = diag(S);

% SVD ellipse
wmin = min(w);
b = scl*wmin./w;
theta = linspace(0,1,50)*2*pi;
p = [b(1)*cos(theta)' b(2)*sin(theta)'];
p = V*p';

% transform coordinates
xnew = V'*x;
fnew = U'*fz;

% SVD gradient
g = V*(w.*fnew);
g = -scl*g/norm(g);

% SVD solution vector
xs = V*(-fnew./w);

% plot SVD diagram
hold on
plot(x(1)+[0 g(1)],x(2)+[0 g(2)],'go-','LineWidth',2);
plot(x(1)+[0 xs(1)],x(2)+[0 xs(2)],'ro-','LineWidth',2);
plot(p(1,:)+x(1),p(2,:)+x(2),'b--','LineWidth',2);
hold off;

xnew = x + xs;





%%

w = diag(S);

